wreport::bufr::DecoderTarget Struct Referenceabstract
Inheritance diagram for wreport::bufr::DecoderTarget:

## Public Member Functions

| DecoderTarget (Input &in)
virtual const Subset & | reference_subset () const =0
| Return the reference to a subset that is receiving the data currently decoded.
virtual Varinfo | lookup_info (unsigned pos) const =0
| Return information about a value previously stored at the given position.
virtual Var | decode_uniform_b_value (Varinfo info)=0
| Decode a value that must always be the same across all datasets.
virtual const Var & | decode_and_add_to_all (Varinfo info)=0
| Decode and add the same value to all datasets, return a reference to one of the variables added.
virtual const Var & | decode_and_add_bitmap (const Tables &tables, Varcode code, unsigned bitmap_size)=0
virtual void | decode_and_set_attribute (Varinfo info, unsigned pos)=0
| Decode an attribute with the given description, and add it to data at position pos.
virtual void | decode_and_add_b_value (Varinfo info)=0
| Decode a B-table value and add its value(s) to the target subset(s).
virtual void | decode_and_add_b_value_with_associated_field (Varinfo info, const bulletin::AssociatedField &field)=0
| Decode a B-table value with associated field, and add its value(s) to the target subset(s).
virtual void | decode_and_add_raw_character_data (Varinfo info)=0
| Decode raw character data described by code and add it to the target subset(s).
virtual int | decode_c03_refval_override (unsigned bits)=0
| Decode the given number of bits a signed integer, to use as a new value for B table reference value.
virtual void | print_last_variable_added (FILE *out)=0
| Print the value(s) of the last variable(s) added to out.
virtual void | print_last_attribute_added (FILE *out, Varcode code, unsigned pos)=0
| Print the value(s) of the last attributes(s) with the given code added to out.

## Data Fields

Input & | in
| Input buffer.

## Member Function Documentation

## decode_and_add_b_value()

virtual void wreport::bufr::DecoderTarget::decode_and_add_b_value | ( | Varinfo | info | ) |

pure virtual

Decode a B-table value and add its value(s) to the target subset(s).

Implemented in wreport::bufr::CompressedDecoderTarget, and wreport::bufr::UncompressedDecoderTarget.

## decode_and_add_b_value_with_associated_field()

virtual void wreport::bufr::DecoderTarget::decode_and_add_b_value_with_associated_field | ( | Varinfo | info,
|  | const bulletin::AssociatedField & | field )

pure virtual

Decode a B-table value with associated field, and add its value(s) to the target subset(s).

Implemented in wreport::bufr::CompressedDecoderTarget, and wreport::bufr::UncompressedDecoderTarget.

## decode_and_add_raw_character_data()

virtual void wreport::bufr::DecoderTarget::decode_and_add_raw_character_data | ( | Varinfo | info | ) |

pure virtual

Decode raw character data described by code and add it to the target subset(s).

Implemented in wreport::bufr::CompressedDecoderTarget, and wreport::bufr::UncompressedDecoderTarget.

## decode_and_add_to_all()

virtual const Var & wreport::bufr::DecoderTarget::decode_and_add_to_all | ( | Varinfo | info | ) |

pure virtual

Decode and add the same value to all datasets, return a reference to one of the variables added.

Implemented in wreport::bufr::CompressedDecoderTarget, and wreport::bufr::UncompressedDecoderTarget.

## decode_and_set_attribute()

virtual void wreport::bufr::DecoderTarget::decode_and_set_attribute | ( | Varinfo | info,
|  | unsigned | pos )

pure virtual

Decode an attribute with the given description, and add it to data at position pos.

Implemented in wreport::bufr::CompressedDecoderTarget, and wreport::bufr::UncompressedDecoderTarget.

## decode_c03_refval_override()

virtual int wreport::bufr::DecoderTarget::decode_c03_refval_override | ( | unsigned | bits | ) |

pure virtual

Decode the given number of bits a signed integer, to use as a new value for B table reference value.

Implemented in wreport::bufr::CompressedDecoderTarget, and wreport::bufr::UncompressedDecoderTarget.

## decode_uniform_b_value()

virtual Var wreport::bufr::DecoderTarget::decode_uniform_b_value | ( | Varinfo | info | ) |

pure virtual

Decode a value that must always be the same across all datasets.

Do not add it to the output.

Returns
  the decoded value

Implemented in wreport::bufr::CompressedDecoderTarget, and wreport::bufr::UncompressedDecoderTarget.

## lookup_info()

virtual Varinfo wreport::bufr::DecoderTarget::lookup_info | ( | unsigned | pos | ) | const

pure virtual

Return information about a value previously stored at the given position.

Implemented in wreport::bufr::CompressedDecoderTarget, and wreport::bufr::UncompressedDecoderTarget.

## print_last_attribute_added()

virtual void wreport::bufr::DecoderTarget::print_last_attribute_added | ( | FILE * | out,
|  | Varcode | code,
|  | unsigned | pos )

pure virtual

Print the value(s) of the last attributes(s) with the given code added to out.

Implemented in wreport::bufr::CompressedDecoderTarget, and wreport::bufr::UncompressedDecoderTarget.

## print_last_variable_added()

virtual void wreport::bufr::DecoderTarget::print_last_variable_added | ( | FILE * | out | ) |

pure virtual

Print the value(s) of the last variable(s) added to out.

Implemented in wreport::bufr::CompressedDecoderTarget, and wreport::bufr::UncompressedDecoderTarget.

## reference_subset()

virtual const Subset & wreport::bufr::DecoderTarget::reference_subset | ( |  | ) | const

pure virtual

Return the reference to a subset that is receiving the data currently decoded.

For uncompressed decoders, this is the current subset. For compressed decoders, it is the first subset.

Implemented in wreport::bufr::CompressedDecoderTarget, and wreport::bufr::UncompressedDecoderTarget.

The documentation for this struct was generated from the following file:

- decoder.h